{SWAG=SZASZ.SWG,SZASZ PAL,SPACEP - unit,SPACEP,MYPACK,UNIT}

{ Updated SZASZ.SWG on February 22, 1997 }

UNIT spacep;

INTERFACE

uses crt;

type pstring=^string;
type tfilenames=array[0..4095] of pstring;
     pfilenames=^tfilenames;
var  infodat:pfilenames;
      Total : Integer;
type tinfopos=array[0..4096] of longint;
VAR pack:boolean;
    InfoPos:^tinfopos;

Function LoadData (num:integer; p:pointer):Boolean;
  { Load raw data into data at pointer "p" }
Function LoadCel  (num:integer; p:pointer):Boolean;
  { Load in a cel into pointer "p" }
Function LoadPCX  (num:integer; where:pointer; dopal : Boolean):Boolean;
  { Load a PCX file to the screen "where"
    Dopal = True sets up the correct PCX pallette, otherwise it leaves
            the pallette alone }
procedure setinfodat(i:integer;s:string);
procedure donespace;
function getfileposition(num:integer;var f:file):boolean;
function getfilesize(num:integer):longint;

IMPLEMENTATION


Procedure DoSinglePal(Col,R,G,B : Byte); assembler;
asm
   mov    dx,3c8h
   mov    al,[col]
   out    dx,al
   inc    dx
   mov    al,[r]
   out    dx,al
   mov    al,[g]
   out    dx,al
   mov    al,[b]
   out    dx,al
end;


Function LoadData (num:integer; p:pointer):Boolean;
VAR f:file;
BEGIN
  If num>=Total then BEGIN
    LoadData:=FALSE;
    exit;
  END;
  If pack then BEGIN
    assign (f,paramstr(0));
    reset (f,1);
    seek (f,infopos^[num]);
    blockread (f, p^, infopos^[num+1]-infopos^[num]);
    close (f);
  END else BEGIN
    assign (f,infodat^[num]^);
    reset (f,1);
    blockread (f, p^, filesize (f));
    close (f);
  END;
END;

function getfileposition(num:integer;var f:file):boolean;
begin
  if num>=total then begin
    getfileposition:=false;
    exit;
  end;
  If pack then BEGIN
    assign (f,paramstr(0));
    reset (f,1);
    seek (f,infopos^[num]);
  END else BEGIN
    assign (f,infodat^[num]^);
    reset (f,1);
  END;
end;

Function LoadCel (num:integer; p:pointer):Boolean;
VAR f:file;
BEGIN
  If num>=Total then BEGIN
    LoadCel:=FALSE;
    exit;
  END;
  If pack then BEGIN
    assign (f,paramstr(0));
    reset (f,1);
    seek (f,infopos^[num]+800);
    blockread (f, p^, infopos^[num+1]-infopos^[num]-800);
    close (f);
  END else BEGIN
    assign (f,infodat^[num]^);
    reset (f,1);
    seek (f,800);
    blockread (f, p^, filesize (f));
    close (f);
  END;
END;

Function LoadPCX (num:integer; where:pointer; dopal : Boolean):Boolean;
VAR f:file;
    res,loop1:word;
    temp:pointer;
    pallette: Array[0..767] Of Byte;
BEGIN
  If num>=Total then BEGIN
    LoadPCX:=FALSE;
    exit;
  END;
  If pack then BEGIN
    assign (f,paramstr(0));
    reset (f,1);
    if dopal then BEGIN
      Seek(f,infopos^[num+1]-768);
      BlockRead(f,pallette,768);
      For loop1:=0 To 255 Do
        dosinglepal (loop1,pallette[loop1*3] shr 2,pallette[loop1*3+1] shr 2,pallette[loop1*3+2] shr 2);
    END;
    seek (f,infopos^[num]+128);
  END else BEGIN
    assign (f,infodat^[num]^);
    reset (f,1);
    if dopal then BEGIN
      Seek(f,FileSize(f)-768);
      BlockRead(f,pallette,768);
      For loop1:=0 To 255 Do
        dosinglepal (loop1,pallette[loop1*3] shr 2,pallette[loop1*3+1] shr 2,pallette[loop1*3+2] shr 2);
    END;
    seek (f,128);
  END;
  getmem (temp,65535);
  blockread (f,temp^,65535,res);
  asm
    push ds
    les di,where
    xor  ch,ch
    lds  si,temp
@Loop1 :
    lodsb
    mov  bl,al
    and  bl,$c0
    cmp  bl,$c0
    jne  @Single

    mov  cl,al
    and  cl,$3f
    lodsb
    rep  stosb
    jmp  @Fin
@Single :
    stosb
@Fin :
    cmp  di,64007
    jbe  @Loop1
    pop  ds
  end;
  freemem (temp,65535);
  close (f);
END;

function getfilesize;
var f:file;
begin
  if num>=total then getfilesize:=0 else
  if pack then getfilesize:=infopos^[num+1]-infopos^[num] else
  begin
    assign(f,infodat^[num]^);reset(f,1);getfilesize:=filesize(f);close(f);
  end;
end;

procedure setinfodat(i:integer;s:string);
var p:pstring;
begin
  getmem(p,length(s)+2);
  p^:=s;
  infodat^[i]:=p;
end;


Procedure Startup;
CONST header : String[42] = #$0d#$0a'SPACE SOFTWARE';
VAR buf : String[43];
    f : file;
    ch:byte;
    i:integer;
    s:string;
BEGIN
  new(infodat);
  new(infopos);
  for i:=0 to 4095 do
    infodat^[i]:=nil;
  Total:=0;
  s:=paramstr(0);
  assign (f,paramstr(0));
  reset (f,1);
  seek (f,filesize(f)-19);
  blockread(f,total,2);
  blockread (f,buf,17);
  if buf=header then BEGIN
    seek (f,filesize(f)-19-(total+1)*4);
    blockread (f,infopos^,(total+1)*4);
    Pack:=TRUE;
  END else BEGIN
    Pack:=FALSE;
  END;
  close (f);
END;

procedure donespace;
var i:integer;
begin
   for i:=0 to total-1 do
     if infodat^[i]<>nil then
       dispose(infodat^[i]);
  dispose(infodat);
  dispose(infopos);
end;

BEGIN
  Startup;
END.